<?php
/**
 * @fileID: $Id: jdefender.php 7949 2012-03-13 11:22:49Z kostya $
 * @changedDate: $LastChangedDate: 2012-03-13 18:22:49 +0700 (Вт, 13 мар 2012) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyDefender Restriction plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined("_JEXEC") or die('Restricted Access');
jimport('joomla.event.plugin');

class plgSystemJdefender extends JPlugin
{

	/**
	 * Site configuration
	 * @var JConfig
	 */
	var $jconfig = null;

	/**
	 * Component options
	 * @var JParameter
	 */
	var $options = null;

	/**
	 * Options in array format :)
	 * @var array
	 */
	var $optionsArray = null;


	function plgSystemJdefender(&$subject)
	{
		parent::__construct($subject);
	}

	function onAfterRoute()
	{
		global $mainframe;

		if ($mainframe->isAdmin()){
			return;
		}

		if (empty($this->options))
		{
			$this->options = & $this->jdGetOptions();
		}

		if (empty($this->jconfig))
		{
			$this->jconfig = new JConfig();
		}

		// SEARCHING FOR ALREADY BLOCKED USERS ******************************************************
		if ($this->jdFindBlocksOnStart())
		{
			$ip =  isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR");
			$referer =  isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : getenv("HTTP_REFERER");

			$email = JHTML::_('email.cloak', $this->jconfig->mailfrom);

			$this->showAlertPage('block_page', $type = false, $email);
		}


		$this->jdStopSpammers();

		// SEARCHING FOR FLOOD *********************************************************************
		if ($this->jdFloodScan())
		{
			$ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR");
			//$referer = getenv("http_referer");
			$type = 'Flood';
			$key = false;
			$val = false;
			$email = JHTML::_('email.cloak', $this->jconfig->mailfrom);

			$this->showAlertPage('stop_page', $type, $email, $key, $val);
		}

		// SCAN FOR INJECTION ***********************************************************************

		$this->jdInjectionScan();

		return true;
	}

	function showAlertPage($page, $type, $email, $key = false, $val = false) {
		jimport ('joomla.filesystem.folder');
		$page = JFolder::makeSafe($page);

		$ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR");
//		$key = false;
//		$val = false;
		$email = JHTML::_('email.cloak', $this->jconfig->mailfrom);

		$lang = & JFactory::getLanguage();

		$tag = $lang->getTag();
		if (!$tag)
			$tag = 'en-GB';

		$file = JPATH_ROOT.DS.'plugins'.DS.'system'.DS.'message_pages'.DS.$tag.DS.$page.'.php';

		if ( ! is_file($file))
			$file = JPATH_ROOT.DS.'plugins'.DS.'system'.DS.'message_pages'.DS.'en-GB'.DS.$page.'.php';

		if ( ! is_file($file) ) {
			JError::raiseError(500, JText::_('Cannot find alert page at').': '.str_replace(JPATH_ROOT, '', $file));
		}
		else {
			include $file;
		}

		exit;
	}

	/**
	 * Fetches the configuraion parameters.
	 * @return unknown_type
	 */
	function & jdGetOptions($asArray = false)
	{
		if (empty($this->options)) {
			require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jdefender'.DS.'models'.DS.'configuration.php';
			$model = & JModel::getInstance('Configuration', 'JDefenderModel');

			$this->options = $model->getData($noXML = true);
		}

		if ($asArray) {
			if (empty($this->optionsArray)) {
				$this->optionsArray = $this->options->toArray();
			}
			return $this->optionsArray;
		}

		return $this->options;
	}


	function jdFindBlocksOnStart()
	{
		global $mainframe;

		require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jdefender'.DS.'helpers'.DS.'block.php';

		$my 		= & $mainframe->getUser();
		$user_id 	= $my->get('id');
		$UserIp 	= isset($_SERVER["REMOTE_ADDR"]) ? $_SERVER["REMOTE_ADDR"] : getenv("REMOTE_ADDR");
		$db			= &JFactory::getDBO();
		$referer 	= isset($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : getenv("HTTP_REFERER");

		$query = "SELECT `type` ".
			"FROM #__jdefender_block_list ".
				"WHERE published = 1 AND ".
			" ( ".
				" (`type` = 'ip' and `value` = " . $db->Quote($UserIp) . ") ".
				($referer ? " or (`type` = 'referer' and `value` LIKE " . $db->Quote('%'.$referer.'%') . ")  " : '').
				($user_id ? " or ( (LOWER(`type`) = 'login' OR LOWER(`type`) = 'user') AND `value` = '" . (int)$user_id . "') " : '').
			' ) ';

		$db->setQuery($query);
		$blockType = $db->loadResult();

		if ( ! $blockType && JD_Block_Helper::isIpBlocked($UserIp, true) )
			$blockType = 'ip';

		if ($blockType)
		{
			$this->jdWriteLog('blocked_users_ips', 'stopped', 'access from blocked '.$blockType);
			return true;
		}
		else
		{
			return false;
		}
	}


	function jdStopSpammers($phpUnit = false)
	{
		$options = & $this->jdGetOptions();

		if ( ! $options->get('spam_enable'))
			return;

		require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jdefender'.DS.'helpers'.DS.'spam.php';

		$ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR");

		$spammer = JD_Spam_Helper::getSpammer($ip);

		if ($spammer)
		{
			if ($phpUnit)
				$this->jdBlock('spam', $spammer, false, true);
			else
				$this->jdBlock('spam', $spammer);
		}
	}


	function jdFloodScan()
	{
		$db 		= & JFactory::getDBO();
		$flood 		= false;
		$options	= & $this->jdGetOptions();
		$UserIp 	= isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR");
		$user		= & JFactory::getUser();

		if ($options->get('flood_scan'))
		{
			$db->setQuery("DELETE FROM `#__jdefender_flood_monitor` WHERE `time` < (now() - INTERVAL 1 DAY)");
			$db->query();

			$db->setQuery("INSERT INTO #__jdefender_flood_monitor (`ip`,`time`) " . "VALUES (".$db->Quote($UserIp).", NOW())");
			$db->query();


			for ($i = 1; $i <= 3; $i++)
			{
				switch ($i)
				{
					case 1:
						$timeofset = " SECOND";
						break;
					case 2:
						$timeofset = " MINUTE";
						break;
					case 3:
						$timeofset = " HOUR";
						break;
				}

				// entodo : find out if the disabled controls save their values.
				$floodOptions = $options->get("flood_condition".$i);
				if (count($floodOptions) == 3)
					array_unshift($floodOptions, 1);

				// Flood condition
				$enabled = is_array($floodOptions) && $floodOptions[ 0 ];

				if ( $enabled )
				{
					$db->setQuery("SELECT COUNT(`ip`) FROM #__jdefender_flood_monitor WHERE `ip` " .
						"= ".$db->Quote($UserIp)." AND `time` >= NOW() - INTERVAL " .
						(int)@$floodOptions[ 2 ] . " $timeofset"
					);

					$count_queries = $db->loadResult();
					if ($count_queries >= @$floodOptions[ 1 ])
					{
						$flood = true;

						if ($options->get('flood_block_ip'))
						{
							$this->jdAddBlockList("ip", $UserIp, 'Flood');
						}

						if ($options->get('flood_block_login') && !$user->guest)
						{
							$this->jdAddBlockList("user", $user->get('id'), 'Flood');
						}
					}
				}
			}

			if ($flood == true)
			{
				$this->jdWriteLog('flood', 'detected', 'flood');

				if ($options->get('flood_alert'))
				{
					$this->jdAlertAdmins("Flood attempt was detected on your site", 'Flood');
				}
			}
		}

		return $flood;
	}


	function jdBlock($type, $key = '', $val = '', $isPHPUnit = false)
	{
		global $mainframe;

		$db = &JFactory::getDBO();
		$options = & $this->jdGetOptions();
		$log = true;
		$reason = '';

		$alertAdmin = false;
		if ($type == 'sql_injection')
		{
			$block_ip 	= $options->get('injection_block_ip');
			$block_user	= $options->get('injection_block_login');
			$block 		= $options->get('injection_reject');
			$alertAdmin = $options->get('injection_alert');

			$reason = 'SQL Injection';
			$issue 		= ($key.' = '.$val);
		}
		elseif ($type == 'php_injection')
		{
			$block_ip 	= $options->get('injection_block_ip');
			$block_user	= $options->get('injection_block_login');
			$block 		= $options->get('injection_reject');
			$alertAdmin = $options->get('injection_alert');

			$reason = 'SQL Injection';
			$issue 		= ($key.' = '.$val);
		}
		elseif ($type == 'spam')
		{
			$spammer = $key;
			if (!$spammer)
				return;

			// Define reason

			$reason = JD_Spam_Helper::codeToString($spammer->attacker);
			if ($reason)
				$reason = JText::_('Spam').': '.$reason;
			else
				$reason = JText::_('Spam');

			$threatPercentage = JD_Spam_Helper::threatToPercentage($spammer->threat);
			$reason .= '. '.JText::_('Threat').': '.$threatPercentage.'%';

			$block_ip 	= $options->get('spam_block_ip');
			$block_user = $options->get('spam_block_login');
			$block 		= $options->get('spam_block');
			$alertAdmin = $options->get('spam_alert'); // :)

			$issue 		= $reason;
		}

		$referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : getenv("HTTP_REFERER");
		$IP 	 = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : getenv("REMOTE_ADDR");

		$uri	= & JFactory::getURI();
		$get 	= $uri->toString();
		$post 	= JRequest::get('post', 2);

		$post 		= serialize($post);
		$my 		= & JFactory::getUser();
		$user_id 	= $my->get('id');

		$sql = "SELECT `id` FROM #__jdefender_log WHERE `ip` = ".$db->Quote($IP)." AND `url` = ".$db->Quote($get)
			." AND post = ".$db->Quote($post)." AND `type` = ".$db->Quote($type) .' AND status = '.$db->Quote($block == true ? 'stopped':'detected')
			." AND `issue` = ".$db->Quote($issue).' AND `ctime` + INTERVAL 1 HOUR > NOW()';

		$db->setQuery($sql, 0, 1);
		$result = $db->loadResult();

		if ($alertAdmin && !$result)
		{
			$this->jdAlertAdmins("{$reason} was detected on your site.", $reason);
		}

		// Write log
		if ($result)
		{
			$sql = "UPDATE #__jdefender_log SET ctime = now() WHERE `id` = '$result'";
			$db->setQuery($sql);
			$db->query();
		}
		else {
			$this->jdWriteLog($type, $block == true ? 'stopped':'detected', $issue);
		}

		// bock ip address if needed;
		if ($block_ip)
		{
			$this->jdAddBlockList('ip', $IP, $reason);
		}

		if ($block_user)
		{
			$this->jdAddBlockList('user', $user_id, $reason);
		}

		// Show stop page
		if ($block_ip or $block or $block_user)
		{
			if ($isPHPUnit)
				return;

			$email = JHTML::_('email.cloak', $this->jconfig->mailfrom);

			$this->showAlertPage('stop_page', $reason, $email, $key, $val);
		}
	}

	function jdWriteLog($type, $status, $issue = '')
	{
		require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jdefender'.DS.'helpers'.DS.'log.php';

		JD_Log_Helper::logSmartly($type, $status, $issue);
	}


	// @TODO: Uploaded files are scanned only for <?php tag. Need add #! shebang scan too :)
	function jdInjectionScan()
	{
		global $mainframe;
		$option = JRequest::getVar('option');

		$email = JHTML::_('email.cloak', $this->jconfig->mailfrom);

		$options = & $this->jdGetOptions();

		$JDRequest = JRequest::get('default', 2);
		#SEARCHING FOR SQL injectionS START *************************************************
		if ($options->get('injection_scan'))
		{
			$keywords = $options->get('sql_keywords');
			$keywords = explode("\n", str_replace("\r", '', $keywords));

			$skipwords = $this->jdGetSkipWords($option, $options->get('sql_exceptions'));

			foreach ($JDRequest as $key => $val)
			{
				if (trim(@$key)=='' || @$key == null){continue;}
				//if (trim((string)$val) == '' || (string)$val = null){continue;}
				if (@is_array($val))
				{
					foreach ($val as $k=> $v)
					{
						if (trim($k)=='' || $k == null){continue;}
						if (!is_array($v) || ($v == null)){continue;}
						if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords))
						{
							continue;
						}
						foreach ($keywords as $keyword)
						{
							if (@preg_match($keyword, $val))
							{
								$this->jdBlock('sql_injection', $key, $val);
							}
						}
					}
				}


				if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords) )
				{
					continue;
				}

				// check ereg rules
				foreach ($keywords as $keyword)
				{
					if (@preg_match($keyword, $val))
					{
						$this->jdBlock('sql_injection', $key, $val);
					}
				}
			}
		}

		//SEARCHING FOR  PHP INJECTIONS
		if ($options->get('injection_scan'))
		{
			$file_rules = $options->get('php_keywords');
			$file_rules = explode("\n", str_replace("\r", "", $file_rules));
			$skipwords = $this->jdGetSkipWords($option, $options->get('php_exceptions'));

			$uri = & JURI::getInstance();
			$domain = $uri->toString(array('host'));

			foreach ($JDRequest as $key => $val)
			{
				if (trim(@$key)=='' || @$key == null){continue;}

				if (@is_array($val))
				{
					foreach ($val as $k => $v)
					{
						if (trim($k)=='' || $k == null || empty($k)){continue;}
						if (!is_array($v) && (trim($v) == '' || $v == null || empty ($v))){continue;}

						if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords))
						{
							continue;
						}
						foreach ($keywords as $keyword)
						{
							if (@preg_match($keyword, $val))
							{
								$this->jdBlock('php_injection', $key, $val);
							}
						}
					}
				}

				if (@in_array(strtolower($key), @$skipwords) || $val ==='' || @in_array("*", @$skipwords))
				{
					continue;
				}

				if (@preg_match("/^(http|https):\/\//", $val) and !@preg_match("/" . $domain . "/", $val))
				{
					if (@preg_match("/url|site|page|location|return/iU", $key))
					{
						continue;
					}
					else
					{
						$this->jdBlock('php_injection', $key, $val);
					}
				}
				// check ereg rules
				foreach ($file_rules as $keyword)
				{
					if (@preg_match($keyword, $val))
					{
						$this->jdBlock('php_injection', $key, $val);
					}
				}
			}
		}
		//SCANNIN THE FILES
		if ($options->get('file_scan'))
		{
			$JDFiles = JRequest::get('FILES');
			if (count($JDFiles)>0)
			{
				jimport('joomla.filesystem.file');
				foreach (@$JDFiles as $key => $val)
				{
					if(in_array(strtolower(JFile::getExt($val['name'])), array('jpg','jpeg','bmp','png','gif','psd','ico','swf')))
					{
						continue;
					}
					if (is_array(@$JDFiles[$key]['tmp_name']))
					{
						foreach (@$JDFiles[$key]['tmp_name'] as $k=>$v)
						{
							//$fp = @fopen(@$_FILES[$key]['tmp_name'][$k], "r");
							$file_content = JFile::read(@$JDFiles[$key]['tmp_name'][$k]);
							if (@preg_match("/<\?php(?:.+)\?>|<\?(?:.+)\?>|^#!/siU", $file_content))
							{
								$this->jdBlock('php_injection', "file_injection", "true");
							}
						}
					}
					else
					{
						if (@$JDFiles[$key]['tmp_name']!='')
						{
							$fp = @fopen(@$JDFiles[$key]['tmp_name'], "r");

							$file_content = fread($fp, @filesize(@$JDFiles[$key]['tmp_name']));

							if (@preg_match("/<\?php(?:.+)\?>|<\?(?:.+)\?>|^#!/siU", $file_content))
							{
								$this->jdBlock('php_injection', "file_injection", "true");
							}
							@fclose($fp);
						}
					}
				}
			}
		}
	}

	function jdAddBlockList($type, $value, $reason = '')
	{
		$db = &JFactory::getDBO();

		if ($value)
		{
			$db->setQuery(
				"select id, published from #__jdefender_block_list WHERE "
					."`type` = " .$db->Quote($type) . " AND `value` = " . $db->Quote($value)
					.' AND `reason` = '.$db->Quote($reason)
			);
			$rows = $db->loadObjectList();

			if ($rows && count($rows)) {
				foreach ($rows as $row) {
					if ($row->published) {
						// Okay, the block rule exists, and it's published. Exit
						return;
					}
				}

				// If all the block rules are upublished, publish the first one, and exit;
				if ( ! empty($rows[ 0 ]->id))
				{
					$db->setQuery("UPDATE #__jdefender_block_list SET `published` = 1 WHERE  id = ".(int)$rows[ 0 ]->id);
					$db->query();

					return;
				}
			}


			$values = array($db->Quote($type), $db->Quote($value), $db->Quote($reason));

			$db->setQuery("insert into #__jdefender_block_list (`type`, `value`, `reason`) values (".implode(', ', $values).")");
			$db->query();

			$this->jdWriteLog('blocked_users_ips', 'blocked', $reason);
		}
	}
	function jdAlertAdmins($subject, $attackType, $issue = false)
	{
		global $mainframe;

//		$options 	= $this->jdGetOptions(true);
		$my 		= $mainframe->getUser();
		$ip 		= isset($_SERVER["REMOTE_ADDR"]) ? $_SERVER["REMOTE_ADDR"] : getenv("REMOTE_ADDR");
		$referer 	= isset($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : getenv("HTTP_REFERER");
		$get		= JRequest::get('get', 2);
		$post		= JRequest::get('post', 2);

		$attackType		= htmlspecialchars($attackType, ENT_QUOTES, 'UTF-8' );

		// Escape the GET and POST arrays HTML Entities.
		$get	= JArrayHelper::toObject($get, 'stdClass');
		$post 	= JArrayHelper::toObject($post, 'stdClass');
		JFilterOutput::objectHTMLSafe($get);
		JFilterOutput::objectHTMLSafe($post);
		$get 	= JArrayHelper::fromObject($get, 	true);
		$post 	= JArrayHelper::fromObject($post, 	true);

		$uri = & JFactory::getURI();

		$text = '<p>'.JText::_('This message was automatically generated by').
			' <a href="http://www.mightyextensions.com/joomla-components/defender-security-firewall">MightyDefender</a></p>';
		$text .= "Attack of type " . $attackType . " was detected on your site.<br />";
		$text .= "Attack URL: ".htmlspecialchars($uri->toString(), ENT_QUOTES, 'UTF-8' )."<br /><br />";

		$text .= "Additional Information:<br />";
		$text .= "---------------------------------------------<br />";
		$text .= " TYPE:     $attackType<br />";
		$text .= " IP:       $ip<br />";

		if (!$my->guest)
			$text .= " USER:     id=$my->id, Username: $my->username, Name; $my->name<br />";

		$text .= " REFERER:  $referer<br />";
		$text .= " GET:      " . nl2br(print_r($get, true)) . '<br />';
		$text .= " POST:     " . nl2br(print_r($post, true)) . "<br />";
		//$text .= " COOKIE:  " . print_r($_COOKIE, true) . "\n";
		//$text .= " SESSION:  ".print_r($_SESSION, true)."\n";
		$text .= "---------------------------------------------<br />";
		$text .= "<br />";
		$text .= "Defender Joomla Bot<br />";

		require_once JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jdefender'.DS.'lib'.DS.'alerts'.DS.'jd_alert.php';

		$alerter = & JD_Alert::getInstance();
		$alerter->send($text);

		// JUtility::sendMail($this->jconfig->mailfrom, 'JDefender systembot', $this->options->get('email'), $subject, $text, 0);
	}

	function jdGetSkipWords($component, $val)
	{
		$out = array();
		if ($val)
		{
			$array = @explode("\n", str_replace("\r", '', $val));
			foreach ($array as $opt)
			{
				$tmp = explode("::", $opt);

				if ($tmp[0] == $component || $tmp[0]=='*')
				{
					$out[] = trim(strtolower(@$tmp[1]));
				}
			}
		}

		return $out;
	}
}
